<html>
<head>
<title>无标题文档</title>
<meta http-equiv="Content-Type" content="text/html; charset=gb2312">
<link rel="stylesheet" href="../css/jinhuaben.css" type="text/css">
</head>

<body bgcolor="#FFFFFF" text="#000000">
<table width="600" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td class="neirong"> 
      <p class="unnamed1">为VC程序加背景图</p>
      <p>VC是一个功能强大的可视化的开发工具，但是用VC做的标准界面与Windows一样色彩灰暗单调，例如多文档窗口应用程序中的主框架窗口的背景便是如此。那么能否给主框架窗口的背景改变一下色彩或是给主框架窗口加上一幅漂亮的图片做背景？其实也不难。但与单文档窗口应用程序中改变框架窗口的背景方法不同，对多文档窗口应用程序中的主框架窗口改变背景不能简单地用ClassWizard重载OnEraseBkgnd(CDC＊ 
        pDC)函数的方法实现。因为多文档窗口应用程序中的主框架窗口的背景区是一个MDIClient类的窗口，因此改变背景与这个MDIClient类的窗口有关。MDIClient类的窗口的句柄是m_hWndMDIClient(在CMDIFrameWnd中)。以下是其实现的步骤： 
        <br>
        <span class="unnamed2">一、 使用MFC AppWizard向导创建一个多文档窗口应用程序 </span><br>
        1.在VC的“File”菜单中单击“New”，弹出“New”对话框。在“Projects”选项卡中选择“MFC AppWizard [exe]”，在“Project 
        name”编辑框中输入“DrawBackground”，单击“OK”按钮，退出“New”对话框。 <br>
        2.在“MFC AppWizard step 1”对话框到“MFC AppWizard step 6”对话框中选择默认选项，单击“Finish”按钮即完成多文档窗口应用程序的定制。 
        <br>
        注：MFC(Microsoft Foundation Class)是MS－Visual C＋＋的类库。 <br>
        <span class="unnamed2">二、向应用程序添加位图 </span><br>
        在VC的“View”菜单中单击“Resource Includes...”，在弹出对话框中选择“Bitmap”，按“Import”按钮从文件中加载位图文件，单击“Workspace”的“Resource”便可见到刚才加载的位图文件，默认的资源标识符为IDB_BITMAP1。 
        <br>
        <span class="unnamed2">三、用ClassWiard生成一个CWnd类的派生类CclientWnd </span><br>
        在CclientWnd类中重载OnEraseBkgnd(CDC＊pDC)，OnSize(UINT nType, int cx, int cy)函数，并用手工加入重载的虚函数WNDPROC＊CClientWnd::GetSuperWndProcAddr()用来返回函数指针。<br>
        类CclientWnd的头文件代码如下： <br>
        class CClientWnd : public CWnd <br>
        { <br>
        // Construction <br>
        public: <br>
        CClient(); <br>
        // Attributes <br>
        public: <br>
        // Operations <br>
        public: <br>
        // Overrides <br>
        // ClassWizard generated virtual function overrides <br>
        file://{{AFX_VIRTUAL(CClientWnd) <br>
        　　　　public: <br>
        virtual WNDPROC＊ GetSuperWndProcAddr(); <br>
        file://}}AFX_VIRTUAL <br>
        // Implementation <br>
        public: <br>
        virtual ～CClientWnd(); <br>
        // Generated message map functions <br>
        protected: <br>
        file://{{AFX_MSG(CClientWnd) <br>
        afx_msg BOOL OnEraseBkgnd(CDC＊ pDC); <br>
        afx_msg void OnSize(UINT nType, int cx, int cy); <br>
        file://}}AFX_MSG <br>
        DECLARE_MESSAGE_MAP() <br>
        }; <br>
        类CclientWnd的实现文件代码如下： <br>
        // CClientWnd message handlers <br>
        BOOL CClientWnd::OnEraseBkgnd(CDC＊ pDC) <br>
        { <br>
        // TODO: Add your message handler code here and/or call default <br>
        CRect rectbk; // 客户区的大小 <br>
        CDC dcMen; // 内存设备描述表 <br>
        CBitmap bmbk; // 位图对象 <br>
        bmbk.LoadBitmap(IDB_BITMAP1); // 从资源加载位图 bitmap <br>
        // 得到位图bitmap的大小 <br>
        BITMAP stBitmap; <br>
        bmbk.GetObject(sizeof(BITMAP),＆stBitmap); <br>
        CSize bmsize(stBitmap.bmWidth,stBitmap.bmHeight); <br>
        //////// <br>
        dcMen.CreateCompatibleDC(pDC); // 创建兼容的设备描述表 <br>
        // 选入新的位图对象并保存旧的位图对象 <br>
        CBitmap ＊pold=dcMen.SelectObject(＆bmbk); <br>
        GetClientRect(＆rectbk); <br>
        // 取得客户区的大小 <br>
        // 从内存向屏幕复制位图对象 <br>
        pDC－&gt;StretchBlt(rectbk.left,rectbk.top,rectbk. Width(), <br>
        rectbk.Height(),＆dcMen,0,0,bmsize.cx,bmsize. cy,SRCCOPY); <br>
        dcMen.SelectObject(pold); <br>
        // 恢复旧的位图对象 <br>
        dcMen.DeleteDC(); <br>
        // 释放内存设备描述表 <br>
        return true; <br>
        } <br>
        WNDPROC＊ CClientWnd::GetSuperWndProcAddr() <br>
        { <br>
        static WNDPROC NEAR pfnSuper = NULL; <br>
        return ＆pfnSuper; // 返回函数指针 <br>
        } <br>
        void CClientWnd::OnSize(UINT nType, int cx, int cy) <br>
        { <br>
        CWnd::OnSize(nType, cx, cy); <br>
        // TODO: Add your message handler code here <br>
        file://重画窗口 <br>
        Invalidate(); <br>
        } <br>
        <span class="unnamed2">四、修改CMainFrame类 </span><br>
        在CMainFrame类中定义一个CClientWnd 类的成员变量m_wndClient，并在CMainFrame::OnCreate(LPCREATESTRUCT 
        lpCreateStruct)函数中把m_wndClient子类化为主框架窗口的客户窗口。代码如下： <br>
        在MainFrm.h 中加入： <br>
        ＃include &quot;ClientWnd1.h&quot; <br>
        class CMainFrame : public CMDIFrameWnd <br>
        { <br>
        private: <br>
        CClientWnd m_wndClient; <br>
        }; <br>
        MainFrm.cpp 中加入代码如下： <br>
        int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) <br>
        { <br>
        if (CMDIFrameWnd::OnCreate(lpCreateStruct) == －1) <br>
        return －1; <br>
        file://把m_wndClient子类化为主框架窗口的客户窗口 <br>
        if(!m_wndClient.SubclassWindow(m_hWndMDIClient)) <br>
        { <br>
        TRACE(&quot;Fail to subclass MDI client window\n&quot;); <br>
        return －1; <br>
        } <br>
        } <br>
        <span class="unnamed2">五、关键技术 </span><br>
        1.本程序并不复杂，关键是要知道多文档窗口应用程序中的主框架窗口的背景区是一个MDIClient类的窗口。 <br>
        2.选用函数要正确，如CclientWnd::OnEraseBkgnd(CDC＊ pDC)函数中选用GetClientRect(＆rectbk) 
        函数来取得客户区的大小要比选用GetClipBox(＆rectbk) 函数来得好。 <br>
        3.要在CclientWnd类中重载OnSize(UINT nType, int cx, int cy) 函数，并加入Invalidate() 
        函数重画窗口。</p>
      <p><br>
        <span class="zhuozhe"> （罗筱波）</span><br>
      </p>
    </td>
  </tr>
</table>
</body>
</html>
